Loading...
Searching...
No Matches
casacore::ImageExprParse Class Reference
images package (libcasa_images) » Images_module

More...

`#include <ImageExprParse.h>`

## Public Member Functions

| ImageExprParse (Bool value)
| Construct a literal object for the given type.
| ImageExprParse (Int value)
| ImageExprParse (Float value)
| ImageExprParse (Double value)
| ImageExprParse (const Complex &value)
| ImageExprParse (const DComplex &value)
| ImageExprParse (const Char *value)
| ImageExprParse (const String &value)
LatticeExprNode | makeFuncNode () const
| Make a LatticeExprNode for a function.
LatticeExprNode | makeFuncNode (const LatticeExprNode &arg1) const
LatticeExprNode | makeFuncNode (const LatticeExprNode &arg1, const LatticeExprNode &arg2) const
LatticeExprNode | makeFuncNode (const LatticeExprNode &arg1, const LatticeExprNode &arg2, const LatticeExprNode &arg3) const
LatticeExprNode | makeLRNode () const
| Make a LatticeExprNode object for the lattice or region name.
LatticeExprNode | makeLitLRNode () const
| Make a LatticeExprNode object for the name of constant, lattice, or region.
LatticeExprNode | makeRegionNode () const
| Make a LatticeExprNode object for the temporary region number.
LatticeExprNode | makeLiteralNode () const
| Make a LatticeExprNode object for the literal value.

## Static Public Member Functions

static LatticeExprNode | command (const String &str, const String &dirName=String())
| Parse the given command.
static LatticeExprNode | command (const String &str, const Block< LatticeExprNode > &tempLattices, const PtrBlock< const ImageRegion * > &tempRegions, const String &dirName=String())
static Slice * | makeSlice (const ImageExprParse &start)
| Make a Slice object from 1-3 literals.
static Slice * | makeSlice (const ImageExprParse &start, const ImageExprParse &end)
static Slice * | makeSlice (const ImageExprParse &start, const ImageExprParse &end, const ImageExprParse &incr)
static LatticeExprNode | makeIndexinNode (const LatticeExprNode &axis, const vector< Slice > &slices)
| Make a node for the INDEXIN function.
static LatticeExprNode | makeValueList (const Block< LatticeExprNode > &values)
| Make an array from a value list.
static IPosition | makeBinning (const LatticeExprNode &values)
| Make an IPosition containing the binning values.
static const vector< String > & | getImageNames ()
| Get the names of the images used in the expression.
static void | setNode (const LatticeExprNode &node)
| Set the static node object (used by the.y file).
static void | addNode (LatticeExprNode *node)
| Keep track of the nodes allocated while parsing the expression.
static void | addNode (ImageExprParse *node)
static void | deleteNodes ()
static String | setAddDir (const String &dirName, const String &fileName)
| A function to test addDir.

## Private Member Functions

Bool | tryLatticeNode (LatticeExprNode &node, const String &name) const
| Try if the name represent a lattice or image.
LatticeExprNode | makeImageNode (const String &name, const String &mask) const
| Make the node from the image name and a mask name.

## Static Private Member Functions

static String | addDir (const String &fileName)
| If a directory was given, prepend it to the file name if relative.
static Table & | getRegionTable (void *, Bool)
| Callback function for RegionHandlerTable to get the table to be used.
static const std::shared_ptr< HDF5File > & | getRegionHDF5 (void *)
| Callback function for RegionHandlerHDF5 to get the file to be used.

## Private Attributes

DataType | itsType
Bool | itsBval
Int | itsIval
Float | itsFval
Double | itsDval
Complex | itsCval
DComplex | itsDCval
String | itsSval

## Static Private Attributes

static LatticeExprNode | theirNode
static vector< String > | theirNames
static Int | theirLevel

## Detailed Description

Class to hold values from image expression parser

### Intended use:

Public interface

### Prerequisite

- LatticeExpr

### Etymology

ImageExprParse is the class used to parse an image expression command.

### Synopsis

ImageExprParse is used by the parser of image expression statements. The parser is written in Bison and Flex in files ImageExprGram.y and.l. The statements in there use the routines in this file to act upon a reduced rule.

The main function (and the only function to be used by a user) is the static function ImageExprParse::command which parses an expression command. It returns a LatticeExprNode object containing the expression represented as a tree. The object can be used as a Lattice(Expr)<T> in other operations.

The syntax of the command is similar to that of expressions in C++. E.g.

min(img1, img2) + sin(img3)
casacore::min
LatticeExprNode min(const LatticeExprNode &left, const LatticeExprNode &right)
casacore::sin
LatticeExprNode sin(const LatticeExprNode &expr)
Numerical 1-argument functions.

The following items can be used in an expression:

- Binary operators +, -, *, /, % (modulo), and ^ (power).
- Unary operators + and -.
- Comparison operators ==, >, >=, <, <=, and !=.
- Logical operators &&, ||, and !.
- Constant single and double precision values.
  No exponent or exponent "e" results in single precision (Float), while "d" results in double precision (Double).
- The imaginary part of a complex value can be given by the suffix "i". A full complex number can be given by addition. E.g. "3+4i". The complex is single (Complex) or double (DComplex) precision depending on the constituting parts.
- The special constants pi and e can be given as a double precision value by means of the functions pi() and e().
- Boolean constants T and F can be given.
- A lot of functions are available. They are the same as the ones supported by class LatticeExprNode.
- Explicit conversion functions float, double, complex and dcomplex are available. Conversions are automatically done where needed, but for performance reasons it may sometimes be better to do explicit conversions. See also below in the first example.
- An image can to be given using its file name. The file name can contain environment variables and user home directories using the standard UNIX syntax $ENVVAR and ~username. There are 3 ways to specify a file name:
  1. When the name contains no other special characters than $, ~, and. it can be given as such.
  2. Backslashes can be used to escape individual special characters.
  3. The full name can be enclosed in quotes (single or double) to escape the entire name. Adjacent quoted parts are combined to one name, which can be used to use quotes in the file name.
  Note that escaping has to be used too for the file name T or F (otherwise it is the boolean constant). E.g.
  image.data
  "~noordam/data/image.data"
  "~/image.data"
  "$HOME/image.data"
  $HOME\/image.data
  "ab'c"'d"e' results in ab'cd"e
  Only input images with data type Float and Complex are supported, because those data types are the only ones used so far. Support of Bool, Double, and DComplex is very simple to build in. The resulting lattice can be of type Bool, Float, Double, Complex, and DComplex.
- An image can also be given by means of the $n notation, where n is the sequence number in the tempLattices argument given to the command function. Note that the sequence numbers start counting at 1 (to be compliant with glish indexing).
  It can, for instance, be used to use non-persistent lattices in an expression.

When the expression is parsed, it is checked if the images and lattices involved have conforming shapes and coordinates. Note, however, that some functions (e.g. mean) reduce an image to a scalar. Such an image can have a different shape and coordinates.

The data types of the images and constants involved can be different. The data type of a subexpression is the common data type (e.g. Float and Double result in Double; Complex and Double result in DComplex). Automatic implicit conversions are done where needed. However, for performance reasons it may sometimes be better to convert explicitly. See below in the first example.

The expression evaluator (which is not part of the parser) evaluates the expression in chunks to avoid having to keep large temporary results. A scalar subexpression is evaluated only once to avoid unnecessary (possibly expensive) calculations.

Some examples:

img1 + min(float(pi()), mean(img2))
  Suppose img1 and img2 are images with single precision data. They do not need to have conforming shapes and coordinates, because only the mean of img2 is used.
  Note that pi is explicitly converted to single precision, because pi() results in a Double. If that was not done, the expression result would be a Double with the effect that all data of img1 had to be converted to Double.
min(img1, (min(img1)+max(img1))/2)
  This example shows that there are 2 min functions. One with a single argument returning the minimum value of that image. The other with 2 arguments returning a lattice containing img1 data clipped at the value of the 2nd argument.

### Example

LatticeExpr<Double> expr ("a + sin(b)");
ArrayLattice<Double> arr(expr.shape());
arr.copyData (expr);
casacore::ArrayLattice
Definition ArrayLattice.h:144
casacore::LatticeExpr
Definition LatticeExpr.h:141

Line 1 creates a LatticeExpr object for the given expression. Note that a and b are names of lattice files (e.g. PagedImage).
Line 2 creates an ArrayLattice with the same shape as the expression (which is the shape of lattice a (and b)).
Line 3 copies the result of the expression to the ArrayLattice.

### Motivation

It is necessary to be able to give an image expression command in ASCII. This can be used in glish to operate on lattices/images.

Definition at line 202 of file ImageExprParse.h.

## Constructor & Destructor Documentation

## ImageExprParse() [1/8]

casacore::ImageExprParse::ImageExprParse | ( | Bool | value | ) |

Construct a literal object for the given type.

References casacore::NewDelAllocator< T >::value.

Referenced by addNode(), makeSlice(), makeSlice(), and makeSlice().

## ImageExprParse() [2/8]

casacore::ImageExprParse::ImageExprParse | ( | Int | value | ) |

References casacore::NewDelAllocator< T >::value.

## ImageExprParse() [3/8]

casacore::ImageExprParse::ImageExprParse | ( | Float | value | ) |

References casacore::NewDelAllocator< T >::value.

## ImageExprParse() [4/8]

casacore::ImageExprParse::ImageExprParse | ( | Double | value | ) |

References casacore::NewDelAllocator< T >::value.

## ImageExprParse() [5/8]

casacore::ImageExprParse::ImageExprParse | ( | const Complex & | value | ) |

References casacore::NewDelAllocator< T >::value.

## ImageExprParse() [6/8]

casacore::ImageExprParse::ImageExprParse | ( | const DComplex & | value | ) |

References casacore::NewDelAllocator< T >::value.

## ImageExprParse() [7/8]

casacore::ImageExprParse::ImageExprParse | ( | const Char * | value | ) |

References casacore::NewDelAllocator< T >::value.

## ImageExprParse() [8/8]

casacore::ImageExprParse::ImageExprParse | ( | const String & | value | ) |

References casacore::NewDelAllocator< T >::value.

## Member Function Documentation

## addDir()

String casacore::ImageExprParse::addDir | ( | const String & | fileName | ) |

static private

If a directory was given, prepend it to the file name if relative.

## addNode() [1/2]

void casacore::ImageExprParse::addNode | ( | ImageExprParse * | node | ) |

static

References ImageExprParse().

## addNode() [2/2]

void casacore::ImageExprParse::addNode | ( | LatticeExprNode * | node | ) |

static

Keep track of the nodes allocated while parsing the expression.

## command() [1/2]

LatticeExprNode casacore::ImageExprParse::command | ( | const String & | str,
|  | const Block< LatticeExprNode > & | tempLattices,
|  | const PtrBlock< const ImageRegion * > & | tempRegions,
|  | const String & | dirName = String() )

static

## command() [2/2]

LatticeExprNode casacore::ImageExprParse::command | ( | const String & | str,
|  | const String & | dirName = String() )

static

Parse the given command.

It will open all lattices needed. It returns the resulting image expression.
The tempLattices/tempRegions arguments make it possible to use temporary lattices/images and regions in the expression by means of the $n notation.
If a directory name is given, it is used instead of the working directory for relative file names.

## deleteNodes()

void casacore::ImageExprParse::deleteNodes | ( |  | ) |

static

## getImageNames()

const vector< String > & casacore::ImageExprParse::getImageNames | ( |  | ) |

inline static

Get the names of the images used in the expression.

Definition at line 281 of file ImageExprParse.h.

References theirNames.

## getRegionHDF5()

const std::shared_ptr< HDF5File > & casacore::ImageExprParse::getRegionHDF5 | ( | void * |  | ) |

static private

Callback function for RegionHandlerHDF5 to get the file to be used.

## getRegionTable()

Table & casacore::ImageExprParse::getRegionTable | ( | void * | ,
|  | Bool | )

static private

Callback function for RegionHandlerTable to get the table to be used.

## makeBinning()

IPosition casacore::ImageExprParse::makeBinning | ( | const LatticeExprNode & | values | ) |

static

Make an IPosition containing the binning values.

## makeFuncNode() [1/4]

LatticeExprNode casacore::ImageExprParse::makeFuncNode | ( |  | ) | const

Make a LatticeExprNode for a function.

## makeFuncNode() [2/4]

LatticeExprNode casacore::ImageExprParse::makeFuncNode | ( | const LatticeExprNode & | arg1 | ) | const

## makeFuncNode() [3/4]

LatticeExprNode casacore::ImageExprParse::makeFuncNode | ( | const LatticeExprNode & | arg1,
|  | const LatticeExprNode & | arg2 ) const

## makeFuncNode() [4/4]

LatticeExprNode casacore::ImageExprParse::makeFuncNode | ( | const LatticeExprNode & | arg1,
|  | const LatticeExprNode & | arg2,
|  | const LatticeExprNode & | arg3 ) const

## makeImageNode()

LatticeExprNode casacore::ImageExprParse::makeImageNode | ( | const String & | name,
|  | const String & | mask ) const

private

Make the node from the image name and a mask name.

The mask name can be NOMASK (case insensitive) meaning that no mask is applied to the image.

References casacore::mask(), and casacore::name().

## makeIndexinNode()

LatticeExprNode casacore::ImageExprParse::makeIndexinNode | ( | const LatticeExprNode & | axis,
|  | const vector< Slice > & | slices )

static

Make a node for the INDEXIN function.

## makeLiteralNode()

LatticeExprNode casacore::ImageExprParse::makeLiteralNode | ( |  | ) | const

Make a LatticeExprNode object for the literal value.

## makeLitLRNode()

LatticeExprNode casacore::ImageExprParse::makeLitLRNode | ( |  | ) | const

Make a LatticeExprNode object for the name of constant, lattice, or region.

## makeLRNode()

LatticeExprNode casacore::ImageExprParse::makeLRNode | ( |  | ) | const

Make a LatticeExprNode object for the lattice or region name.

## makeRegionNode()

LatticeExprNode casacore::ImageExprParse::makeRegionNode | ( |  | ) | const

Make a LatticeExprNode object for the temporary region number.

## makeSlice() [1/3]

Slice * casacore::ImageExprParse::makeSlice | ( | const ImageExprParse & | start | ) |

static

Make a Slice object from 1-3 literals.

References ImageExprParse().

## makeSlice() [2/3]

Slice * casacore::ImageExprParse::makeSlice | ( | const ImageExprParse & | start,
|  | const ImageExprParse & | end )

static

References ImageExprParse().

## makeSlice() [3/3]

Slice * casacore::ImageExprParse::makeSlice | ( | const ImageExprParse & | start,
|  | const ImageExprParse & | end,
|  | const ImageExprParse & | incr )

static

References ImageExprParse().

## makeValueList()

LatticeExprNode casacore::ImageExprParse::makeValueList | ( | const Block< LatticeExprNode > & | values | ) |

static

Make an array from a value list.

## setAddDir()

String casacore::ImageExprParse::setAddDir | ( | const String & | dirName,
|  | const String & | fileName )

static

A function to test addDir.

It first sets the directory.

## setNode()

void casacore::ImageExprParse::setNode | ( | const LatticeExprNode & | node | ) |

inline static

Set the static node object (used by the.y file).

Definition at line 285 of file ImageExprParse.h.

References theirNode.

## tryLatticeNode()

Bool casacore::ImageExprParse::tryLatticeNode | ( | LatticeExprNode & | node,
|  | const String & | name ) const

private

Try if the name represent a lattice or image.

Return False if not.

References casacore::name().

## Member Data Documentation

## itsBval

Bool casacore::ImageExprParse::itsBval

private

Definition at line 327 of file ImageExprParse.h.

## itsCval

Complex casacore::ImageExprParse::itsCval

private

Definition at line 331 of file ImageExprParse.h.

## itsDCval

DComplex casacore::ImageExprParse::itsDCval

private

Definition at line 332 of file ImageExprParse.h.

## itsDval

Double casacore::ImageExprParse::itsDval

private

Definition at line 330 of file ImageExprParse.h.

## itsFval

Float casacore::ImageExprParse::itsFval

private

Definition at line 329 of file ImageExprParse.h.

## itsIval

Int casacore::ImageExprParse::itsIval

private

Definition at line 328 of file ImageExprParse.h.

## itsSval

String casacore::ImageExprParse::itsSval

private

Definition at line 333 of file ImageExprParse.h.

## itsType

DataType casacore::ImageExprParse::itsType

private

Definition at line 326 of file ImageExprParse.h.

## theirLevel

Int casacore::ImageExprParse::theirLevel

static private

Definition at line 324 of file ImageExprParse.h.

## theirNames

vector<String> casacore::ImageExprParse::theirNames

static private

Definition at line 323 of file ImageExprParse.h.

Referenced by getImageNames().

## theirNode

LatticeExprNode casacore::ImageExprParse::theirNode

static private

Definition at line 319 of file ImageExprParse.h.

Referenced by setNode().

The documentation for this class was generated from the following file:

- images/Images/ImageExprParse.h